#!/bin/bash
TMP_ZETTELKASTEN=""

setup() {
    source ../zk

    TMP_ZETTELKASTEN="$(mktemp -d)"
}

teardown() {
    rm -rf "$TMP_ZETTELKASTEN"
}

test__zk_new_creates_file_in_correct_directory() {
    fake "$EDITOR" echo ""
    fake vi echo ""

    export ZKDIR="$TMP_ZETTELKASTEN"
    filename="aaaaaaaaaaaaaa"
    fake date "echo $filename"

    _zk_new

    assert "test -e $TMP_ZETTELKASTEN/$filename"
}

test__zk_new_runs_EDITOR_if_EDITOR_is_set() {
    export EDITOR="nano"
    # shellcheck disable=SC2016
    fake "$EDITOR" echo '$EDITOR ${FAKE_PARAMS[@]}'

    export ZKDIR="$TMP_ZETTELKASTEN"
    filename="aaaaaaaaaaaaaa"
    fake date "echo $filename"
    expected="$EDITOR $TMP_ZETTELKASTEN/$filename"

    result="$(_zk_new)"

    assert_equals "$expected" "$result"
}

test__zk_new_runs_vi_if_EDITOR_is_not_set() {
    export EDITOR=""
    # shellcheck disable=SC2016
    fake vi echo 'vi ${FAKE_PARAMS[@]}'

    export ZKDIR="$TMP_ZETTELKASTEN"
    filename="aaaaaaaaaaaaaa"
    fake date "echo $filename"
    expected="vi $TMP_ZETTELKASTEN/$filename"

    result="$(_zk_new)"

    assert_equals "$expected" "$result"
}

